//////////////////////////////////////////////////////////////////////////////
// GP32.h                                                                   //
//////////////////////////////////////////////////////////////////////////////
/*
	yet another GP32.h :P
*/

#ifndef __GP32_H
#define __GP32_H

//////////////////////////////////////////////////////////////////////////////
// Defines                                                                  //
//////////////////////////////////////////////////////////////////////////////
/* Memory control */
#define rBWSCON		(*(volatile unsigned *)0x14000000)
#define rBANKCON0		(*(volatile unsigned *)0x14000004)
#define rBANKCON1		(*(volatile unsigned *)0x14000008)
#define rBANKCON2		(*(volatile unsigned *)0x1400000c)
#define rBANKCON3		(*(volatile unsigned *)0x14000010)
#define rBANKCON4		(*(volatile unsigned *)0x14000014)
#define rBANKCON5		(*(volatile unsigned *)0x14000018)
#define rBANKCON6		(*(volatile unsigned *)0x1400001c)
#define rBANKCON7		(*(volatile unsigned *)0x14000020)
#define rREFRESH		(*(volatile unsigned *)0x14000024)
#define rBANKSIZE		(*(volatile unsigned *)0x14000028)
#define rMRSRB6		(*(volatile unsigned *)0x1400002c)
#define rMRSRB7		(*(volatile unsigned *)0x14000030)

/* INTERRUPT */
#define rSRCPND		(*(volatile unsigned *)0x14400000)
#define rINTMOD		(*(volatile unsigned *)0x14400004)
#define rINTMSK		(*(volatile unsigned *)0x14400008)
#define rPRIORITY		(*(volatile unsigned *)0x1440000c)
#define rINTPND		(*(volatile unsigned *)0x14400010)
#define rINTOFFSET	(*(volatile unsigned *)0x14400014)

/* DMA */
#define rDISRC0		(*(volatile unsigned *)0x14600000)
#define rDIDST0		(*(volatile unsigned *)0x14600004)
#define rDCON0			(*(volatile unsigned *)0x14600008)
#define rDSTAT0		(*(volatile unsigned *)0x1460000c)
#define rDCSRC0		(*(volatile unsigned *)0x14600010)
#define rDCDST0		(*(volatile unsigned *)0x14600014)
#define rDMASKTRIG0	(*(volatile unsigned *)0x14600018)
#define rDISRC1		(*(volatile unsigned *)0x14600020)
#define rDIDST1		(*(volatile unsigned *)0x14600024)
#define rDCON1			(*(volatile unsigned *)0x14600028)
#define rDSTAT1		(*(volatile unsigned *)0x1460002c)
#define rDCSRC1		(*(volatile unsigned *)0x14600030)
#define rDCDST1		(*(volatile unsigned *)0x14600034)
#define rDMASKTRIG1	(*(volatile unsigned *)0x14600038)
#define rDISRC2		(*(volatile unsigned *)0x14600040)
#define rDIDST2		(*(volatile unsigned *)0x14600044)
#define rDCON2			(*(volatile unsigned *)0x14600048)
#define rDSTAT2		(*(volatile unsigned *)0x1460004c)
#define rDCSRC2		(*(volatile unsigned *)0x14600050)
#define rDCDST2		(*(volatile unsigned *)0x14600054)
#define rDMASKTRIG2	(*(volatile unsigned *)0x14600058)
#define rDISRC3		(*(volatile unsigned *)0x14600060)
#define rDIDST3		(*(volatile unsigned *)0x14600064)
#define rDCON3			(*(volatile unsigned *)0x14600068)
#define rDSTAT3		(*(volatile unsigned *)0x1460006c)
#define rDCSRC3		(*(volatile unsigned *)0x14600070)
#define rDCDST3		(*(volatile unsigned *)0x14600074)
#define rDMASKTRIG3	(*(volatile unsigned *)0x14600078)

/* CLOCK & POWER MANAGEMENT */
#define rLOCKTIME		(*(volatile unsigned *)0x14800000)
#define rMPLLCON		(*(volatile unsigned *)0x14800004)
#define rUPLLCON		(*(volatile unsigned *)0x14800008)
#define rCLKCON		(*(volatile unsigned *)0x1480000c)
#define rCLKSLOW		(*(volatile unsigned *)0x14800010)
#define rCLKDIVN		(*(volatile unsigned *)0x14800014)

/* LCD CONTROLLER */
#define rLCDCON1		(*(volatile unsigned *)0x14a00000)
#define rLCDCON2		(*(volatile unsigned *)0x14a00004)
#define rLCDCON3		(*(volatile unsigned *)0x14a00008)
#define rLCDCON4		(*(volatile unsigned *)0x14a0000c)
#define rLCDCON5		(*(volatile unsigned *)0x14a00010)
#define rLCDSADDR1	(*(volatile unsigned *)0x14a00014)
#define rLCDSADDR2	(*(volatile unsigned *)0x14a00018)
#define rLCDSADDR3	(*(volatile unsigned *)0x14a0001c)
#define rREDLUT		(*(volatile unsigned *)0x14a00020)
#define rGREENLUT		(*(volatile unsigned *)0x14a00024)
#define rBLUELUT		(*(volatile unsigned *)0x14a00028)
#define rDP1_2			(*(volatile unsigned *)0x14a0002c)
#define rDP4_7			(*(volatile unsigned *)0x14a00030)
#define rDP3_5			(*(volatile unsigned *)0x14a00034)
#define rDP2_3			(*(volatile unsigned *)0x14a00038)
#define rDP5_7			(*(volatile unsigned *)0x14a0003c)
#define rDP3_4			(*(volatile unsigned *)0x14a00040)
#define rDP4_5			(*(volatile unsigned *)0x14a00044)
#define rDP6_7			(*(volatile unsigned *)0x14a00048)
#define rDITHMODE		(*(volatile unsigned *)0x14a0004c)
#define rTPAL			(*(volatile unsigned *)0x14a00050)
#define LCD_PALETTE	(0x14a00400)
#define LCDSADDR1		(0x14a00014)

/* UART */
#define rULCON0		(*(volatile unsigned *)0x15000000)
#define rUCON0			(*(volatile unsigned *)0x15000004)
#define rUFCON0		(*(volatile unsigned *)0x15000008)
#define rUMCON0		(*(volatile unsigned *)0x1500000c)
#define rUTRSTAT0		(*(volatile unsigned *)0x15000010)
#define rUERSTAT0		(*(volatile unsigned *)0x15000014)
#define rUFSTAT0		(*(volatile unsigned *)0x15000018)
#define rUMSTAT0		(*(volatile unsigned *)0x1500001c)
#define rUBRDIV0		(*(volatile unsigned *)0x15000028)

#define rULCON1		(*(volatile unsigned *)0x15004000)
#define rUCON1			(*(volatile unsigned *)0x15004004)
#define rUFCON1		(*(volatile unsigned *)0x15004008)
#define rUMCON1		(*(volatile unsigned *)0x1500400c)
#define rUTRSTAT1		(*(volatile unsigned *)0x15004010)
#define rUERSTAT1		(*(volatile unsigned *)0x15004014)
#define rUFSTAT1		(*(volatile unsigned *)0x15004018)
#define rUMSTAT1		(*(volatile unsigned *)0x1500401c)
#define rUBRDIV1		(*(volatile unsigned *)0x15004028)

#define rUTXH0			(*(volatile unsigned char *)0x15000020)
#define rURXH0			(*(volatile unsigned char *)0x15000024)
#define rUTXH1			(*(volatile unsigned char *)0x15004020)
#define rURXH1			(*(volatile unsigned char *)0x15004024)

#define WrUTXH0(ch)	(*(volatile unsigned char *)0x15000020)=(unsigned char)(ch)
#define RdURXH0()		(*(volatile unsigned char *)0x15000024)
#define WrUTXH1(ch)	(*(volatile unsigned char *)0x15004020)=(unsigned char)(ch)
#define RdURXH1()		(*(volatile unsigned char *)0x15004024)

#define UTXH0			(0x15000020)    //byte_access address by DMA
#define URXH0			(0x15000024)
#define UTXH1			(0x15004020)
#define URXH1			(0x15004024)

/* PWM TIMER */
#define rTCFG0			(*(volatile unsigned *)0x15100000)
#define rTCFG1			(*(volatile unsigned *)0x15100004)
#define rTCON			(*(volatile unsigned *)0x15100008)
#define rTCNTB0		(*(volatile unsigned *)0x1510000c)
#define rTCMPB0		(*(volatile unsigned *)0x15100010)
#define rTCNTO0		(*(volatile unsigned *)0x15100014)
#define rTCNTB1		(*(volatile unsigned *)0x15100018)
#define rTCMPB1		(*(volatile unsigned *)0x1510001c)
#define rTCNTO1		(*(volatile unsigned *)0x15100020)
#define rTCNTB2		(*(volatile unsigned *)0x15100024)
#define rTCMPB2		(*(volatile unsigned *)0x15100028)
#define rTCNTO2		(*(volatile unsigned *)0x1510002c)
#define rTCNTB3		(*(volatile unsigned *)0x15100030)
#define rTCMPB3		(*(volatile unsigned *)0x15100034)
#define rTCNTO3		(*(volatile unsigned *)0x15100038)
#define rTCNTB4		(*(volatile unsigned *)0x1510003c)
#define rTCNTO4		(*(volatile unsigned *)0x15100040)

/* USB DEVICE */
#define rFUNC_ADDR_REG	(*(volatile unsigned *)0x15200140)
#define rPWR_REG			(*(volatile unsigned *)0x15200144)
#define rINT_REG			(*(volatile unsigned *)0x15200148)
#define rINT_MASK_REG	(*(volatile unsigned *)0x1520014c)
#define rFRAME_NUM_REG	(*(volatile unsigned *)0x15200150)
#define rRESUME_CON_REG	(*(volatile unsigned *)0x15200154)
#define rEP0_CSR			(*(volatile unsigned *)0x15200160)
#define rEP0_MAXP			(*(volatile unsigned *)0x15200164)
#define rEP0_OUT_CNT		(*(volatile unsigned *)0x15200168)
#define rEP0_FIFO			(*(volatile unsigned *)0x1520016c)
#define rEP1_IN_CSR		(*(volatile unsigned *)0x15200180)
#define rEP1_IN_MAXP		(*(volatile unsigned *)0x15200184)
#define rEP1_FIFO			(*(volatile unsigned *)0x15200188)
#define rEP2_IN_CSR		(*(volatile unsigned *)0x15200190)
#define rEP2_IN_MAXP		(*(volatile unsigned *)0x15200194)
#define rEP2_FIFO			(*(volatile unsigned *)0x15200198)
#define rEP3_OUT_CSR		(*(volatile unsigned *)0x152001a0)
#define rEP3_OUT_MAXP	(*(volatile unsigned *)0x152001a4)
#define rEP3_OUT_CNT		(*(volatile unsigned *)0x152001a8)
#define rEP3_FIFO			(*(volatile unsigned *)0x152001ac)
#define rEP4_OUT_CSR		(*(volatile unsigned *)0x152001b0)
#define rEP4_OUT_MAXP	(*(volatile unsigned *)0x152001b4)
#define rEP4_OUT_CNT		(*(volatile unsigned *)0x152001b8)
#define rEP4_FIFO			(*(volatile unsigned *)0x152001bc)
#define rDMA_CON			(*(volatile unsigned *)0x152001c0)
#define rDMA_UNIT			(*(volatile unsigned *)0x152001c4)
#define rDMA_FIFO			(*(volatile unsigned *)0x152001c8)
#define rDMA_TX			(*(volatile unsigned *)0x152001cc)
#define rTEST_MODE		(*(volatile unsigned *)0x152001f4)
#define rIN_CON_REG		(*(volatile unsigned *)0x152001f8)

/* WATCH DOG TIMER */
#define rWTCON			(*(volatile unsigned *)0x15300000)
#define rWTDAT			(*(volatile unsigned *)0x15300004)
#define rWTCNT			(*(volatile unsigned *)0x15300008)

/* IIC */
#define rIICCON		(*(volatile unsigned *)0x15400000)
#define rIICSTAT		(*(volatile unsigned *)0x15400004)
#define rIICADD		(*(volatile unsigned *)0x15400008)
#define rIICDS			(*(volatile unsigned *)0x1540000c)

/* IIS */
#define rIISCON		(*(volatile unsigned *)0x15508000)
#define rIISMOD		(*(volatile unsigned *)0x15508004)
#define rIISPSR		(*(volatile unsigned *)0x15508008)
#define rIISFIFCON	(*(volatile unsigned *)0x1550800c)
#define IISFIF			((volatile unsigned short *)0x15508010)

/* I/O PORT */
#define rPACON			(*(volatile unsigned *)0x15600000)
#define rPADAT			(*(volatile unsigned *)0x15600004)

#define rPBCON			(*(volatile unsigned *)0x15600008)
#define rPBDAT			(*(volatile unsigned *)0x1560000c)
#define rPBUP			(*(volatile unsigned *)0x15600010)

#define rPCCON			(*(volatile unsigned *)0x15600014)
#define rPCDAT			(*(volatile unsigned *)0x15600018)
#define rPCUP			(*(volatile unsigned *)0x1560001c)

#define rPDCON			(*(volatile unsigned *)0x15600020)
#define rPDDAT			(*(volatile unsigned *)0x15600024)
#define rPDUP			(*(volatile unsigned *)0x15600028)

#define rPECON			(*(volatile unsigned *)0x1560002c)
#define rPEDAT			(*(volatile unsigned *)0x15600030)
#define rPEUP			(*(volatile unsigned *)0x15600034)

#define rPFCON			(*(volatile unsigned *)0x15600038)
#define rPFDAT			(*(volatile unsigned *)0x1560003c)
#define rPFUP			(*(volatile unsigned *)0x15600040)

#define rPGCON			(*(volatile unsigned *)0x15600044)
#define rPGDAT			(*(volatile unsigned *)0x15600048)
#define rPGUP			(*(volatile unsigned *)0x1560004c)

#define rOPENCR		(*(volatile unsigned *)0x15600050)
#define rMISCCR		(*(volatile unsigned *)0x15600054)
#define rEXTINT		(*(volatile unsigned *)0x15600058)

/* RTC */
#define rRTCCON		(*(volatile unsigned char *)0x15700040)
#define rRTCALM		(*(volatile unsigned char *)0x15700050)
#define rALMSEC		(*(volatile unsigned char *)0x15700054)
#define rALMMIN		(*(volatile unsigned char *)0x15700058)
#define rALMHOUR		(*(volatile unsigned char *)0x1570005c)
#define rALMDAY		(*(volatile unsigned char *)0x15700060)
#define rALMMON		(*(volatile unsigned char *)0x15700064)
#define rALMYEAR		(*(volatile unsigned char *)0x15700068)
#define rRTCRST		(*(volatile unsigned char *)0x1570006c)
#define rBCDSEC		(*(volatile unsigned char *)0x15700070)
#define rBCDMIN		(*(volatile unsigned char *)0x15700074)
#define rBCDHOUR		(*(volatile unsigned char *)0x15700078)
#define rBCDDAY		(*(volatile unsigned char *)0x1570007c)
#define rBCDDATE		(*(volatile unsigned char *)0x15700080)
#define rBCDMON		(*(volatile unsigned char *)0x15700084)
#define rBCDYEAR		(*(volatile unsigned char *)0x15700088)
#define rTICINT		(*(volatile unsigned char *)0x15700044)

/* ADC */
#define rADCCON		(*(volatile unsigned *)0x15800000)
#define rADCDAT		(*(volatile unsigned *)0x15800004)

/* SPI */
#define rSPCON			(*(volatile unsigned *)0x15900000)
#define rSPSTA			(*(volatile unsigned *)0x15900004)
#define rSPPIN			(*(volatile unsigned *)0x15900008)
#define rSPPRE			(*(volatile unsigned *)0x1590000c)
#define rSPTDAT		(*(volatile unsigned *)0x15900010)
#define rSPRDAT		(*(volatile unsigned *)0x15900014)

/* MMC INTERFACE */
#define rMMCON			(*(volatile unsigned char *)0x15a00000)
#define rMMCRR			(*(volatile unsigned char *)0x15a00004)
#define rMMFCON		(*(volatile unsigned char *)0x15a00008)
#define rMMSTA			(*(volatile unsigned char *)0x15a0000c)
#define rMMFSTA		(*(volatile unsigned short *)0x15a00010)
#define rMMPRE			(*(volatile unsigned char *)0x15a00014)
#define rMMLEN			(*(volatile unsigned short *)0x15a00018)
#define rMMCR7			(*(volatile unsigned *)0x15a0001c)
#define rMMRSP0		(*(volatile unsigned *)0x15a00020)
#define rMMRSP1		(*(volatile unsigned *)0x15a00024)
#define rMMRSP2		(*(volatile unsigned *)0x15a00028)
#define rMMRSP3		(*(volatile unsigned *)0x15a0002c)
#define rMMCMD0		(*(volatile unsigned char *)0x15a00030)
#define rMMCMD1		(*(volatile unsigned *)0x15a00034)
#define rMMCR16		(*(volatile unsigned short *)0x15a00038)
#define rMMDAT			(*(volatile unsigned char *)0x15a0003c)

/* ISR */

#define _ISR_STARTADDRESS (0x0c7ac000)

#define pISR_EINT0	(*(unsigned *)(_ISR_STARTADDRESS+0x00))
#define pISR_EINT1	(*(unsigned *)(_ISR_STARTADDRESS+0x04))
#define pISR_EINT2	(*(unsigned *)(_ISR_STARTADDRESS+0x08))
#define pISR_EINT3	(*(unsigned *)(_ISR_STARTADDRESS+0x0c))
#define pISR_EINT4	(*(unsigned *)(_ISR_STARTADDRESS+0x10))
#define pISR_EINT5	(*(unsigned *)(_ISR_STARTADDRESS+0x14))
#define pISR_EINT6	(*(unsigned *)(_ISR_STARTADDRESS+0x18))
#define pISR_EINT7	(*(unsigned *)(_ISR_STARTADDRESS+0x1c))
#define pISR_TICK		(*(unsigned *)(_ISR_STARTADDRESS+0x20))
#define pISR_WDT		(*(unsigned *)(_ISR_STARTADDRESS+0x24))
#define pISR_TIMER0	(*(unsigned *)(_ISR_STARTADDRESS+0x28))
#define pISR_TIMER1	(*(unsigned *)(_ISR_STARTADDRESS+0x2c))
#define pISR_TIMER2	(*(unsigned *)(_ISR_STARTADDRESS+0x30))
#define pISR_TIMER3	(*(unsigned *)(_ISR_STARTADDRESS+0x34))
#define pISR_TIMER4	(*(unsigned *)(_ISR_STARTADDRESS+0x38))
#define pISR_UERR01	(*(unsigned *)(_ISR_STARTADDRESS+0x3c))
#define pISR_NOTUSED	(*(unsigned *)(_ISR_STARTADDRESS+0x40))
#define pISR_DMA0		(*(unsigned *)(_ISR_STARTADDRESS+0x44))
#define pISR_DMA1		(*(unsigned *)(_ISR_STARTADDRESS+0x48))
#define pISR_DMA2		(*(unsigned *)(_ISR_STARTADDRESS+0x4c))
#define pISR_DMA3		(*(unsigned *)(_ISR_STARTADDRESS+0x50))
#define pISR_MMC		(*(unsigned *)(_ISR_STARTADDRESS+0x54))
#define pISR_SPI		(*(unsigned *)(_ISR_STARTADDRESS+0x58))
#define pISR_URXD0	(*(unsigned *)(_ISR_STARTADDRESS+0x5c))
#define pISR_URXD1	(*(unsigned *)(_ISR_STARTADDRESS+0x60))
#define pISR_USBD		(*(unsigned *)(_ISR_STARTADDRESS+0x64))
#define pISR_USBH		(*(unsigned *)(_ISR_STARTADDRESS+0x68))
#define pISR_IIC		(*(unsigned *)(_ISR_STARTADDRESS+0x6c))
#define pISR_UTXD0	(*(unsigned *)(_ISR_STARTADDRESS+0x70))
#define pISR_UTXD1	(*(unsigned *)(_ISR_STARTADDRESS+0x74))
#define pISR_RTC		(*(unsigned *)(_ISR_STARTADDRESS+0x78))
#define pISR_ADC		(*(unsigned *)(_ISR_STARTADDRESS+0x7C))

/* Interrupt numbers */
#define nINT_EINT0		(0)
#define nINT_EINT1		(1)
#define nINT_EINT2		(2)
#define nINT_EINT3		(3)
#define nINT_EINT4		(4)
#define nINT_EINT5		(5)
#define nINT_EINT6		(6)
#define nINT_EINT7		(7)
#define nINT_TICK			(8)
#define nINT_WDT			(9)
#define nINT_TIMER0		(10)
#define nINT_TIMER1		(11)
#define nINT_TIMER2		(12)
#define nINT_TIMER3		(13)
#define nINT_TIMER4		(14)
#define nINT_UERR01		(15)
/* 16 is not used */
#define nINT_DMA0			(17)
#define nINT_DMA1			(18)
#define nINT_DMA2			(19)
#define nINT_DMA3			(20)
#define nINT_MMC			(21)
#define nINT_SPI			(22)
#define nINT_URXD0		(23)
#define nINT_URXD1		(24)
#define nINT_USBD			(25)
#define nINT_USBH			(26)
#define nINT_IIC			(27)
#define nINT_UTXD0		(28)
#define nINT_UTXD1		(29)
#define nINT_RTC			(30)
#define nINT_ADC			(31)

/* PENDING BIT */
#define BIT_EINT0			(1<<nINT_EINT0)
#define BIT_EINT1			(1<<nINT_EINT1)
#define BIT_EINT2			(1<<nINT_EINT2)
#define BIT_EINT3			(1<<nINT_EINT3)
#define BIT_EINT4			(1<<nINT_EINT4)
#define BIT_EINT5			(1<<nINT_EINT5)
#define BIT_EINT6			(1<<nINT_EINT6)
#define BIT_EINT7			(1<<nINT_EINT7)
#define BIT_TICK			(1<<nINT_TICK)
#define BIT_WDT			(1<<nINT_WDT)
#define BIT_TIMER0		(1<<nINT_TIMER0)
#define BIT_TIMER1		(1<<nINT_TIMER1)
#define BIT_TIMER2		(1<<nINT_TIMER2)
#define BIT_TIMER3		(1<<nINT_TIMER3)
#define BIT_TIMER4		(1<<nINT_TIMER4)
#define BIT_UERR01		(1<<nINT_UERR01)
/* 16 is not used */
#define BIT_DMA0			(1<<nINT_DMA0)
#define BIT_DMA1			(1<<nINT_DMA1)
#define BIT_DMA2			(1<<nINT_DMA2)
#define BIT_DMA3			(1<<nINT_DMA3)
#define BIT_MMC			(1<<nINT_MMC)
#define BIT_SPI			(1<<nINT_SPI)
#define BIT_URXD0			(1<<nINT_URXD0)
#define BIT_URXD1			(1<<nINT_URXD1)
#define BIT_USBD			(1<<nINT_USBD)
#define BIT_USBH			(1<<nINT_USBH)
#define BIT_IIC			(1<<nINT_IIC)
#define BIT_UTXD0			(1<<nINT_UTXD0)
#define BIT_UTXD1			(1<<nINT_UTXD1)
#define BIT_RTC			(1<<nINT_RTC)
#define BIT_ADC			(1<<nINT_ADC)
#define BIT_ALLMSK		(0xffffffff)

#define ClearPending(bit) {\
		 rSRCPND = bit;\
		 rINTPND = bit;\
		 rINTPND;\
		 }
//Wait until rINTPND is changed for the case that the ISR is very short.


#define bENVID 		(0)
#define bBPPMODE		(1)
#define bPNRMODE		(5)
#define bMMODE			(7)
#define bCLKVAL		(8)
#define bLINECNT		(18)

#define bVSPW			(0)
#define bVFPD			(6)
#define bLINEVAL		(14)
#define bVBPD			(24)

#define bHFPD			(0)
#define bHOZVAL		(8)
#define bHBPD			(19)

#define bHSPW			(0)
#define bMVAL			(8)
#define bADDVAL		(16)
#define bPALADDEN		(24)

#define bHWSWP			(0)
#define bBSWP			(1)
#define bENLEND		(2)
#define bRESERVED1	(3)
#define bINVENDLINE	(4)
#define bRESERVED2	(5)
#define bINVVDEN		(6)
#define bINVVD			(7)
#define bINVVFRAME	(8)
#define bINVVLINE		(9)
#define bINVVCLK		(10)
#define bRESERVED3	(11)
#define bSELFREF		(13)
#define bSLOWCLKSYNC	(14)
#define bRESERVED4	(15)
#define bHSTATUS		(17)
#define bVSTATUS		(19)


#define bLCDBASEU		(0)
#define bLCDBANK		(21)

#define bLCDBASEL		(0)

#define bPAGEWIDTH	(0)
#define bOFFSIZE		(11)

/* Memory areas for the LCD buffers.
 * These are the standard GPSDK buffers (I think)
 */
#define SCREEN_BUFFER_1  ((unsigned char *)0xC7B4000)
#define SCREEN_BUFFER_2  ((unsigned char *)0xC7C6C00)
#define SCREEN_BUFFER_3  ((unsigned char *)0xC7D9800)
#define SCREEN_BUFFER_4  ((unsigned char *)0xC7EC400)

/* A useful little macro for working with colours */
#define RGBI(r,g,b,i) ((unsigned short)((r<<11)+(g<<6)+(b<<1)+i))

/* Masks for identifying which button is pressed */
#define BUTTONMASK_SELECT		(512)
#define BUTTONMASK_START		(256)
#define BUTTONMASK_A				(128)
#define BUTTONMASK_B				(64)
#define BUTTONMASK_LEFT			(32)
#define BUTTONMASK_RIGHT		(16)
#define BUTTONMASK_JOYRIGHT	(8)
#define BUTTONMASK_JOYLEFT		(4)
#define BUTTONMASK_JOYDOWN		(2)
#define BUTTONMASK_JOYUP		(1)

/* This variable holds the pressed keys */
extern volatile int x_gp32_nKeys;

/* Key polling function. Must be called regularly. */
void x_gp32_ReadKeys (void);

/* Declaration of the text font data in x_font.c */
extern const unsigned char x_gp32_fontresEng[];

/* In some cases I've found interrupts (mostly sound-related)
 * did not work. Calling ArmEnableCPSRInterrupt fixed it.
 */
void x_gp32_ArmEnableCPSRInterrupt (void);

/* For temporarily disabling interrupts, use the following pair of
 * functions. DO NOT NEST CALLS! If you call XArmDisableInterrupt
 * twice without calling XArmEnableInterrupt in between, interrupts
 * will be permanently disabled.
 */
void x_gp32_XArmEnableInterrupt (void);
void x_gp32_XArmDisableInterrupt (void);

/* Get the clock speeds from the CPU */
long x_gp32_GetPCLK (void);
long x_gp32_GetHCLK (void);

/* Set the CPU speed, takes the same numbers as GpClockSpeedSet */
void x_gp32_SetCPUSpeed (const long speed, const int mult, const int flags);

static inline void x_gp32_SetCPUSpeed_133(void) { x_gp32_SetCPUSpeed(132000000, 0x24001, 2); }
static inline void x_gp32_SetCPUSpeed_100(void) { x_gp32_SetCPUSpeed(99000000, 0x3a002, 2); }
static inline void x_gp32_SetCPUSpeed_80(void) { x_gp32_SetCPUSpeed(80000000, 0x48012, 2); }
static inline void x_gp32_SetCPUSpeed_66(void) { x_gp32_SetCPUSpeed(67500000, 0x25002, 1); }
static inline void x_gp32_SetCPUSpeed_60(void) { x_gp32_SetCPUSpeed(59250000, 0x47022, 1); }


/* Standard palette setting, takes 256 x 16-bit numbers, uses them to fill
 * the 8-bit colour mode palette
 */
void x_gp32_RealisePalette (const unsigned short *pPalette);

/* Set the graphics mode, use this before any other graphics operations */
void x_gp32_SetGraphicsMode (const int bpp);

/* If SetGraphicsMode has been called, then call ShutdownGraphics before
 * exiting the program, otherwise the LCD will be screwed up
 */
void x_gp32_ShutdownGraphics (void);

/* Pretty cheesy BitBlt, I'm sure there are better ones out there. */
void x_gp32_BitBlt ( unsigned char *dest, int dx, int dy, int width, int height, unsigned char *src, int sx, int sy );

/* Set the memory area to be displayed on the LCD */
void x_gp32_SetLcdBuffer (unsigned char *buf);

/* Set the memory area to be printed to by TextOut */
void x_gp32_SetPrintBase (unsigned char *buf);

/* Render text into memory for display on the LCD */
void x_gp32_TextOut (const int x, const int y, const char *text, unsigned char colour);

/* Wait for LCD vertical blank */
static inline void x_gp32_WaitVBL (void)
{
   while (((rLCDCON1>>18)&0x3ff)<100);
   while (((rLCDCON1>>18)&0x3ff)>50);
}

/* Get CPU's PSR register, not quite sure what this might be useful for */
unsigned int x_gp32_GetCPSR (void);

/* Install an interrupt service routine */
void x_gp32_IsrInstall(unsigned long nr,void *ptr);

/* Uninstall an interrupt service routine */
void x_gp32_IsrUninstall(unsigned long nr);

/* This flushes and disables the caches and write buffer */
void x_gp32_PreMmuSetup (void);

/* Re-enable the caches and write buffer */
void x_gp32_PostMmuSetup (void);

/* Set up the MMU tables for 32MB memory. */
void x_gp32_SetupMemory (void);

/* Find the MMU Translation Table base */
unsigned int *x_gp32_GetTTB (void);

/* Set MMU for normal operation with 8MB */
void x_gp32_SetupMemoryNormal (void);

/* Initialise the SMC library. */
int SmcInit (void);

extern int x_gp32_cpumhz;

void x_gp32_dma_MMUChange(void *start, void *end, int flags);

void x_gp32_EnableIRQ(void);
void x_gp32_DisableIRQ(void);
void x_gp32_InstallSWIIRQ(int irqnumber,void *addr);
void x_gp32_RemoveSWIIRQ (int irqnumber,void *addr);

void x_gp32_NOP(void);

extern unsigned int x_gp32_timer_counter;

static inline void x_gp32_waitVsync()
{ while ((rLCDCON1 >> 18) !=   1); while ((rLCDCON1 >> 18) != 319); }

static inline void x_gp32_drawPixel8 ( int x, int y, unsigned char c, unsigned char *framebuffer )
{ *(framebuffer +(239-y)+(240*x) ) = c; }

static inline void x_gp32_drawPixel16 ( int x, int y, unsigned short c, unsigned short *framebuffer )
{ *(framebuffer +(239-y)+(240*x) ) = c; }

void x_gp32_setFramebuffer(unsigned int addr,int vsync);
short x_gp32_initFramebuffer(unsigned int addr,unsigned short bitmode,unsigned short refreshrate);
void x_gp32_setPalette( unsigned char pos,unsigned short color);

#endif	// __GP32_H
